From 46e1090dc12ab6714a3a87f42a58e0c94c34ff77 Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Tue, 20 Oct 2020 16:26:16 +0200
Subject: [PATCH] icons: add journal icon (#47814)

---
 gadjo/static/css/gadjo.scss |   2 +-
 icons/journal.svg           | 230 ++++++++++++++++++++++++++++++++++++
 2 files changed, 231 insertions(+), 1 deletion(-)
 create mode 100644 icons/journal.svg

diff --git a/gadjo/static/css/gadjo.scss b/gadjo/static/css/gadjo.scss
index 1c6a5d9..72fe5a6 100644
--- a/gadjo/static/css/gadjo.scss
+++ b/gadjo/static/css/gadjo.scss
@@ -1043,7 +1043,7 @@ div.old-ie-warning p {
 
 $string-color: str-slice($primary-color + '', 2);
 
-$appicons: add, agendas, announces, book, calendar, cards, categories, clock, counter, data, facturier, forms, gis, grid, home, mail, management, organizational-units, passerelle, password, phone, portal, portal-agent, porte-doc, roles, security, services, settings, statistics, studio, submission, system, texts, theme, users, workflows;
+$appicons: add, agendas, announces, book, calendar, cards, categories, clock, counter, data, facturier, forms, gis, grid, home, journal, mail, management, organizational-units, passerelle, password, phone, portal, portal-agent, porte-doc, roles, security, services, settings, statistics, studio, submission, system, texts, theme, users, workflows;
 
 @each $appicon in $appicons {
 	ul#sidepage-menu li a.icon-#{$appicon} { background-image: url(icons/#{$appicon}.small.#{$string-color}.png); }
diff --git a/icons/journal.svg b/icons/journal.svg
new file mode 100644
index 0000000..68a795b
--- /dev/null
+++ b/icons/journal.svg
@@ -0,0 +1,230 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   id="Calque_1"
+   data-name="Calque 1"
+   viewBox="0 0 55.61 55.16"
+   version="1.1"
+   sodipodi:docname="journal.svg"
+   inkscape:version="1.0.1 (3bc2e813f5, 2020-09-07)">
+  <metadata
+     id="metadata37">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title>Pictos_v3_EXPORT</dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <sodipodi:namedview
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1"
+     objecttolerance="10"
+     gridtolerance="10"
+     guidetolerance="10"
+     inkscape:pageopacity="0"
+     inkscape:pageshadow="2"
+     inkscape:window-width="1920"
+     inkscape:window-height="1016"
+     id="namedview35"
+     showgrid="false"
+     inkscape:zoom="9.4221082"
+     inkscape:cx="45.116609"
+     inkscape:cy="39.671897"
+     inkscape:window-x="0"
+     inkscape:window-y="27"
+     inkscape:window-maximized="1"
+     inkscape:current-layer="Calque_1"
+     inkscape:document-rotation="0" />
+  <defs
+     id="defs4">
+    <style
+       id="style2">.cls-1{fill:#242d3c;}</style>
+  </defs>
+  <title
+     id="title6">Pictos_v3_EXPORT</title>
+  <path
+     class="cls-1"
+     d="M 55.622074,55.150553 H 0.01207431 L 0,0 h 55.61 z m -53.3899997,-2.22 H 53.402074 L 53.39,2.22 H 2.22 Z"
+     id="path8"
+     sodipodi:nodetypes="cccccccccc" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-7.3301182"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12"
+     style="stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="27.669867"
+     y="3.4077144"
+     width="0.87651753"
+     height="48.460415"
+     id="rect14"
+     style="stroke-width:2.93576"
+     ry="0.43825877" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-13.187033"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-3"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-19.043961"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-6"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-24.900875"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-7"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-30.75779"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-5"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-36.614677"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-35"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-42.471592"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-62"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="5.2801094"
+     y="-48.328506"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-9"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-7.3301182"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-1"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-13.187032"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-3-2"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-19.043943"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-6-7"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-24.900858"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-7-0"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-30.757771"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-5-9"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-36.614681"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-35-3"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-42.471596"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-62-6"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+  <rect
+     class="cls-1"
+     x="31.615086"
+     y="-48.328506"
+     width="19.095919"
+     height="0.70393473"
+     id="rect12-9-0"
+     style="fill:#242d3c;stroke-width:1.65152"
+     transform="scale(1,-1)"
+     ry="0.35196736" />
+</svg>
-- 
2.28.0