From 524bcaf348bfa5aa0f183a2a785b369a8a0ff770 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 23 Oct 2020 17:01:37 +0200
Subject: [PATCH] add minsant theme (#48009)

---
 static/minsant/_custom.scss      |  81 +++++++++++++++++++++++++++++++
 static/minsant/_vars.scss        |  27 +++++++++++
 static/minsant/config.json       |  14 ++++++
 static/minsant/img/coin-menu.png | Bin 0 -> 2852 bytes
 static/minsant/img/logo.png      | Bin 0 -> 18343 bytes
 static/minsant/style.scss        |   5 ++
 6 files changed, 127 insertions(+)
 create mode 100644 static/minsant/_custom.scss
 create mode 100644 static/minsant/_vars.scss
 create mode 100644 static/minsant/config.json
 create mode 100644 static/minsant/img/coin-menu.png
 create mode 100644 static/minsant/img/logo.png
 create mode 100644 static/minsant/style.scss

diff --git a/static/minsant/_custom.scss b/static/minsant/_custom.scss
new file mode 100644
index 00000000..e4036979
--- /dev/null
+++ b/static/minsant/_custom.scss
@@ -0,0 +1,81 @@
+@import '../includes/fonts/titillium';
+
+.site-header {
+	background: $primary-color;
+}
+
+#header {
+	color: white;
+	font-family: Titillium;
+	h1#logo a {
+		line-height: 170px;
+		font-size: 2.667rem;
+		color: white;
+		font-weight: normal;
+		background-size: auto 150px;
+		width: 90%;
+	}
+}
+
+#toplinks {
+	.sep, .registration {
+		display: none;
+	}
+}
+
+#nav {
+	li {
+		border-left: 1px;
+		border-right: 1px;
+		border-top: 0;
+		border-bottom: 0;
+		border-style: solid;
+		border-color: $primary-color;
+	}
+	ul {
+		margin-top: 0;
+		a {
+			font-weight: normal;
+			padding: 20px 30px;
+		}
+		li.selected > a {
+			background-image: url(img/coin-menu.png);
+			background-position: top right;
+			background-repeat: no-repeat;
+		}
+	}
+}
+
+#footer-wrapper {
+	border-top: 15px solid $secondary-color;
+	#footer {
+		min-height: 100px;
+		background: url(img/logo-footer.png) top right no-repeat;
+	}
+}
+
+div#right.account-management {
+	display: none;
+}
+
+body.has-picture nav::after {
+	background-size: contain;
+}
+
+#columns div.cell {
+	background-image: linear-gradient(to top right, white 50%, $secondary-color);
+	background-size: 50px 40px;
+	background-repeat: no-repeat;
+	background-position: top right;
+	h2:first-child {
+		font-weight: bold;
+		font-size: 1.2em;
+		background: none;
+	}
+}
+
+#sidebar div.cell {
+	background-color: $primary-color;
+	border-left: 1px;
+	border-left-style: solid;
+}
diff --git a/static/minsant/_vars.scss b/static/minsant/_vars.scss
new file mode 100644
index 00000000..1f04acd9
--- /dev/null
+++ b/static/minsant/_vars.scss
@@ -0,0 +1,27 @@
+$primary-color: #f3f3f3;
+$secondary-color: #697b98;
+
+$body-background: $primary-color;
+$sidebar-position: right;
+
+$font-family: Arial, sans-serif;
+$width: 1160px;
+$font-color: #000;
+$font-size: 0.938em;
+$link-color: #365268;
+$nav-full-width-background: true;
+$nav-background: white;
+$nav-submenu-color: black;;
+$nav-active-background: $secondary-color;
+$nav-item-selected-color: white;
+$nav-item-selected-background: $secondary-color;
+$nav-item-hover-background: $secondary-color;
+$nav-item-hover-color: white;
+$cell-border: 0;
+$cell-title-cover-border: false;
+$border-radius: 0;
+$button-background: $secondary-color;
+$title-font-family: Titillium;
+$title-background: $secondary-color;
+$footer-background: $primary-color;
+$footer-color: $secondary-color;
diff --git a/static/minsant/config.json b/static/minsant/config.json
new file mode 100644
index 00000000..acbe88de
--- /dev/null
+++ b/static/minsant/config.json
@@ -0,0 +1,14 @@
+{
+  "label": "Ministère des Solidarités et de la Santé",
+  "variables": {
+    "theme_color": "#f3f3f3"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:background": { "label": "Têtière : fond" },
+        "header:logo": { "label": "Têtière : logo" }
+      }
+    }
+  }
+}
diff --git a/static/minsant/img/coin-menu.png b/static/minsant/img/coin-menu.png
new file mode 100644
index 0000000000000000000000000000000000000000..fcd4e948f4c7c022fe5fb583455e4ffa0809344b
GIT binary patch
diff --git a/static/minsant/img/logo.png b/static/minsant/img/logo.png
new file mode 100644
index 0000000000000000000000000000000000000000..7b2be78a648e2d797b604e850c04c15b6c15b506
GIT binary patch
diff --git a/static/minsant/style.scss b/static/minsant/style.scss
new file mode 100644
index 00000000..1fd447de
--- /dev/null
+++ b/static/minsant/style.scss
@@ -0,0 +1,5 @@
+@charset "UTF-8";
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.28.0