From 25baa306ec63e275464e15df871f30e32e38e7b1 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 23 Oct 2020 13:53:24 +0200
Subject: [PATCH] gers-cd32: add CSS class for pictos on links (#48011)

---
 static/gers-cd32/_custom.scss                 |  80 ++++++++++++++++++
 static/gers-cd32/icons/ico-24.png             | Bin 0 -> 4010 bytes
 static/gers-cd32/icons/ico-baby.png           | Bin 0 -> 3660 bytes
 static/gers-cd32/icons/ico-bin.png            | Bin 0 -> 1698 bytes
 static/gers-cd32/icons/ico-box.png            | Bin 0 -> 2456 bytes
 static/gers-cd32/icons/ico-bulding.png        | Bin 0 -> 1189 bytes
 static/gers-cd32/icons/ico-bus.png            | Bin 0 -> 1943 bytes
 static/gers-cd32/icons/ico-citation.png       | Bin 0 -> 2195 bytes
 static/gers-cd32/icons/ico-cone.png           | Bin 0 -> 2003 bytes
 static/gers-cd32/icons/ico-contact.png        | Bin 0 -> 2351 bytes
 .../gers-cd32/icons/ico-demarche_en_ligne.png | Bin 0 -> 2409 bytes
 static/gers-cd32/icons/ico-doctor.png         | Bin 0 -> 3120 bytes
 static/gers-cd32/icons/ico-download.png       | Bin 0 -> 1680 bytes
 static/gers-cd32/icons/ico-event.png          | Bin 0 -> 1358 bytes
 static/gers-cd32/icons/ico-guitar.png         | Bin 0 -> 3644 bytes
 static/gers-cd32/icons/ico-hemicycle.png      | Bin 0 -> 3115 bytes
 .../icons/ico-j_ai_mon_mot_a_dire.png         | Bin 0 -> 2050 bytes
 static/gers-cd32/icons/ico-j_ai_une_idee.png  | Bin 0 -> 2700 bytes
 static/gers-cd32/icons/ico-kite.png           | Bin 0 -> 2802 bytes
 static/gers-cd32/icons/ico-library.png        | Bin 0 -> 1163 bytes
 static/gers-cd32/icons/ico-list.png           | Bin 0 -> 1475 bytes
 static/gers-cd32/icons/ico-localisation.png   | Bin 0 -> 3821 bytes
 static/gers-cd32/icons/ico-location.png       | Bin 0 -> 3225 bytes
 static/gers-cd32/icons/ico-map.png            | Bin 0 -> 3882 bytes
 static/gers-cd32/icons/ico-news.png           | Bin 0 -> 1446 bytes
 static/gers-cd32/icons/ico-news_1.png         | Bin 0 -> 3077 bytes
 static/gers-cd32/icons/ico-parking.png        | Bin 0 -> 2256 bytes
 static/gers-cd32/icons/ico-phone.png          | Bin 0 -> 3231 bytes
 static/gers-cd32/icons/ico-phonebook.png      | Bin 0 -> 2792 bytes
 static/gers-cd32/icons/ico-photos.png         | Bin 0 -> 3343 bytes
 static/gers-cd32/icons/ico-pool.png           | Bin 0 -> 3335 bytes
 static/gers-cd32/icons/ico-rate_filled.png    | Bin 0 -> 2082 bytes
 static/gers-cd32/icons/ico-rate_outline.png   | Bin 0 -> 2918 bytes
 .../icons/ico-reinventer_le_gers.png          | Bin 0 -> 3172 bytes
 static/gers-cd32/icons/ico-script.png         | Bin 0 -> 2193 bytes
 35 files changed, 80 insertions(+)
 create mode 100644 static/gers-cd32/icons/ico-24.png
 create mode 100644 static/gers-cd32/icons/ico-baby.png
 create mode 100644 static/gers-cd32/icons/ico-bin.png
 create mode 100644 static/gers-cd32/icons/ico-box.png
 create mode 100644 static/gers-cd32/icons/ico-bulding.png
 create mode 100644 static/gers-cd32/icons/ico-bus.png
 create mode 100644 static/gers-cd32/icons/ico-citation.png
 create mode 100644 static/gers-cd32/icons/ico-cone.png
 create mode 100644 static/gers-cd32/icons/ico-contact.png
 create mode 100644 static/gers-cd32/icons/ico-demarche_en_ligne.png
 create mode 100644 static/gers-cd32/icons/ico-doctor.png
 create mode 100644 static/gers-cd32/icons/ico-download.png
 create mode 100644 static/gers-cd32/icons/ico-event.png
 create mode 100644 static/gers-cd32/icons/ico-guitar.png
 create mode 100644 static/gers-cd32/icons/ico-hemicycle.png
 create mode 100644 static/gers-cd32/icons/ico-j_ai_mon_mot_a_dire.png
 create mode 100644 static/gers-cd32/icons/ico-j_ai_une_idee.png
 create mode 100644 static/gers-cd32/icons/ico-kite.png
 create mode 100644 static/gers-cd32/icons/ico-library.png
 create mode 100644 static/gers-cd32/icons/ico-list.png
 create mode 100644 static/gers-cd32/icons/ico-localisation.png
 create mode 100644 static/gers-cd32/icons/ico-location.png
 create mode 100644 static/gers-cd32/icons/ico-map.png
 create mode 100644 static/gers-cd32/icons/ico-news.png
 create mode 100644 static/gers-cd32/icons/ico-news_1.png
 create mode 100644 static/gers-cd32/icons/ico-parking.png
 create mode 100644 static/gers-cd32/icons/ico-phone.png
 create mode 100644 static/gers-cd32/icons/ico-phonebook.png
 create mode 100644 static/gers-cd32/icons/ico-photos.png
 create mode 100644 static/gers-cd32/icons/ico-pool.png
 create mode 100644 static/gers-cd32/icons/ico-rate_filled.png
 create mode 100644 static/gers-cd32/icons/ico-rate_outline.png
 create mode 100644 static/gers-cd32/icons/ico-reinventer_le_gers.png
 create mode 100644 static/gers-cd32/icons/ico-script.png

diff --git a/static/gers-cd32/_custom.scss b/static/gers-cd32/_custom.scss
index a00afdef..595ecb67 100644
--- a/static/gers-cd32/_custom.scss
+++ b/static/gers-cd32/_custom.scss
@@ -95,16 +95,96 @@ div.cell.foldable.folded > div > h2:first-child + picture {
 	display: block;
 }
 
 #sidebar {
 	box-shadow: 3px 3px 20px 0px #dedede;
 	margin-right: 2.5em;
 }
 
+$icons: (
+	"24": "ico-24.png",
+	"baby": "ico-baby.png",
+	"bin": "ico-bin.png",
+	"box": "ico-box.png",
+	"bulding": "ico-bulding.png",
+	"bus": "ico-bus.png",
+	"citation": "ico-citation.png",
+	"cone": "ico-cone.png",
+	"contact": "ico-contact.png",
+	"demarche_en_ligne": "ico-demarche_en_ligne.png",
+	"doctor": "ico-doctor.png",
+	"download": "ico-download.png",
+	"event": "ico-event.png",
+	"guitar": "ico-guitar.png",
+	"hemicycle": "ico-hemicycle.png",
+	"j_ai_mon_mot_a_dire": "ico-j_ai_mon_mot_a_dire.png",
+	"j_ai_une_idee": "ico-j_ai_une_idee.png",
+	"kite": "ico-kite.png",
+	"library": "ico-library.png",
+	"list": "ico-list.png",
+	"localisation": "ico-localisation.png",
+	"location": "ico-location.png",
+	"map": "ico-map.png",
+	"news_1": "ico-news_1.png",
+	"news": "ico-news.png",
+	"parking": "ico-parking.png",
+	"phonebook": "ico-phonebook.png",
+	"phone": "ico-phone.png",
+	"photos": "ico-photos.png",
+	"pool": "ico-pool.png",
+	"rate_filled": "ico-rate_filled.png",
+	"rate_outline": "ico-rate_outline.png",
+	"reinventer_le_gers": "ico-reinventer_le_gers.png",
+	"script": "ico-script.png"
+);
+
+@each $name, $file in $icons {
+	div.linkcell.icon-#{$name} a {
+		background-image: url(icons/#{$file});
+		background-repeat: no-repeat;
+	}
+}
+
+@mixin after-line($color: #cbd05d) {
+	&::after {
+		display: block;
+		margin-top: 0.5em;
+		content: '';
+		background: $color;
+		width: 2em;
+		height: 2px;
+	}
+}
+
+div.linkcell.homepage-link {
+	border: 1px solid #d2d2d2;
+	font-weight: bold;
+	text-transform: uppercase;
+	font-size: 90%;
+	a {
+		padding-top: 5rem;
+		@media screen and ($max-mobile-viewport) {
+			padding-top: 1rem;
+			padding-left: 5rem;
+		}
+		@include after-line(#000);
+	}
+	&[class*=" icon-"] {
+		a {
+			background-position: 1rem 1rem;
+			background-size: auto 2.5rem;
+			display: block;
+			@media screen and ($max-mobile-viewport) {
+				background-position: 1rem center;
+			}
+		}
+	}
+}
+
 @mixin form-icon($content) {
 	content: $content;
 	font-family: FontAwesome;
 }
 
 div#footer-wrapper {
 	padding: 66px 0 73px;
 }
diff --git a/static/gers-cd32/icons/ico-24.png b/static/gers-cd32/icons/ico-24.png
new file mode 100644
index 0000000000000000000000000000000000000000..e5c5712a1de1bf79070f5f7be1613815e725f13f
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-baby.png b/static/gers-cd32/icons/ico-baby.png
new file mode 100644
index 0000000000000000000000000000000000000000..6080d500b0ca48b5baf16bc917eb91d394956451
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-bin.png b/static/gers-cd32/icons/ico-bin.png
new file mode 100644
index 0000000000000000000000000000000000000000..f2efa1be1d9141c64802fabd5786e665b228cb60
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-box.png b/static/gers-cd32/icons/ico-box.png
new file mode 100644
index 0000000000000000000000000000000000000000..429ea26312cef2af41f371dc9e94626d61f9670c
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-bulding.png b/static/gers-cd32/icons/ico-bulding.png
new file mode 100644
index 0000000000000000000000000000000000000000..94ed87b9b4818c35e9fdb088ca8b96f31d4a2496
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-bus.png b/static/gers-cd32/icons/ico-bus.png
new file mode 100644
index 0000000000000000000000000000000000000000..cc34451c65fa1790851fe4a65cc204202db9e4a5
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-citation.png b/static/gers-cd32/icons/ico-citation.png
new file mode 100644
index 0000000000000000000000000000000000000000..a2ed3a8426b0a0db2218699c025416dd487127f4
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-cone.png b/static/gers-cd32/icons/ico-cone.png
new file mode 100644
index 0000000000000000000000000000000000000000..8e6260351fa21e9fcfbd296ecf3d9b1247e7f543
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-contact.png b/static/gers-cd32/icons/ico-contact.png
new file mode 100644
index 0000000000000000000000000000000000000000..acb236b57792f2ee6ec3691aaf26a559bd196cd6
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-demarche_en_ligne.png b/static/gers-cd32/icons/ico-demarche_en_ligne.png
new file mode 100644
index 0000000000000000000000000000000000000000..983fe19551baebdc3261ac02c4b9562e50b61cca
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-doctor.png b/static/gers-cd32/icons/ico-doctor.png
new file mode 100644
index 0000000000000000000000000000000000000000..176648e5f1d5d6eced9b581a3b4c927bfeba4352
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-download.png b/static/gers-cd32/icons/ico-download.png
new file mode 100644
index 0000000000000000000000000000000000000000..83442e883128850d7ae9e2cc485773f569185085
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-event.png b/static/gers-cd32/icons/ico-event.png
new file mode 100644
index 0000000000000000000000000000000000000000..79a39ad0968f63f6554662d079894f2586d1a4c7
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-guitar.png b/static/gers-cd32/icons/ico-guitar.png
new file mode 100644
index 0000000000000000000000000000000000000000..9d3e912e606030bb37956919a5e49643a441c765
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-hemicycle.png b/static/gers-cd32/icons/ico-hemicycle.png
new file mode 100644
index 0000000000000000000000000000000000000000..c262686571a668441072b516f9e8930cbc97ef09
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-j_ai_mon_mot_a_dire.png b/static/gers-cd32/icons/ico-j_ai_mon_mot_a_dire.png
new file mode 100644
index 0000000000000000000000000000000000000000..5f20d91dd32c88e17cef37c70ef4e9ea3a6b15a2
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-j_ai_une_idee.png b/static/gers-cd32/icons/ico-j_ai_une_idee.png
new file mode 100644
index 0000000000000000000000000000000000000000..45d5431289d406b59eb15fa734028a1d27cdce4c
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-kite.png b/static/gers-cd32/icons/ico-kite.png
new file mode 100644
index 0000000000000000000000000000000000000000..ccd37458fb632be00aa63f991ba6473878f9487d
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-library.png b/static/gers-cd32/icons/ico-library.png
new file mode 100644
index 0000000000000000000000000000000000000000..b882141daef503cd55ca9f4a7118e49bce85276c
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-list.png b/static/gers-cd32/icons/ico-list.png
new file mode 100644
index 0000000000000000000000000000000000000000..8aab252025d9c9cc9b0975aed3509ab8a94f9a8b
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-localisation.png b/static/gers-cd32/icons/ico-localisation.png
new file mode 100644
index 0000000000000000000000000000000000000000..d5ab80ceb2235362a3bd726955b787610d8ba0ce
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-location.png b/static/gers-cd32/icons/ico-location.png
new file mode 100644
index 0000000000000000000000000000000000000000..84a8b3d2ac591aee66ee72431e79394be019e2f1
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-map.png b/static/gers-cd32/icons/ico-map.png
new file mode 100644
index 0000000000000000000000000000000000000000..2bb7a1d3457302c84c598a59da0edac32f9db3b4
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-news.png b/static/gers-cd32/icons/ico-news.png
new file mode 100644
index 0000000000000000000000000000000000000000..e4b44bbb366a2e7796ef7d0091dca1893981d49d
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-news_1.png b/static/gers-cd32/icons/ico-news_1.png
new file mode 100644
index 0000000000000000000000000000000000000000..6ebd7de72bd5eb529037e2db10d01f530e5b738a
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-parking.png b/static/gers-cd32/icons/ico-parking.png
new file mode 100644
index 0000000000000000000000000000000000000000..26619b65e2e406e566a9ad468153706bf0072552
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-phone.png b/static/gers-cd32/icons/ico-phone.png
new file mode 100644
index 0000000000000000000000000000000000000000..6c167da27d4ed3985b4ed8f15e1c2ef29f67a8d0
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-phonebook.png b/static/gers-cd32/icons/ico-phonebook.png
new file mode 100644
index 0000000000000000000000000000000000000000..a501b3af0ba86cd15b4324d8120a2b6a4f0996fc
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-photos.png b/static/gers-cd32/icons/ico-photos.png
new file mode 100644
index 0000000000000000000000000000000000000000..c843d22d857ebc42c891ec6f6e1ff94530009b82
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-pool.png b/static/gers-cd32/icons/ico-pool.png
new file mode 100644
index 0000000000000000000000000000000000000000..7b6ecff0c6d362a64af2e8099fdf03d568ba8d7e
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-rate_filled.png b/static/gers-cd32/icons/ico-rate_filled.png
new file mode 100644
index 0000000000000000000000000000000000000000..de0148b9f3e024e53ea70d3461311eae56be594a
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-rate_outline.png b/static/gers-cd32/icons/ico-rate_outline.png
new file mode 100644
index 0000000000000000000000000000000000000000..69fa187a6134b35635242728b281047d9570a15d
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-reinventer_le_gers.png b/static/gers-cd32/icons/ico-reinventer_le_gers.png
new file mode 100644
index 0000000000000000000000000000000000000000..e7b1ae7ee637b8e33615e5753aebf482bd11e46c
GIT binary patch
diff --git a/static/gers-cd32/icons/ico-script.png b/static/gers-cd32/icons/ico-script.png
new file mode 100644
index 0000000000000000000000000000000000000000..cda4306bfbee9f97d1f9a06e1ba6a2bf8bff9f13
GIT binary patch
-- 
2.28.0